using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {
        static int Partition(int[] niz, int levi, int desni)                              
        {     
            int pivot = niz[desni];
            int manji = (levi - 1);
            for (int j = levi; j < desni; j++)
            {
                if (niz[j] <= pivot)
                {
                    manji++;
                    Razmena(ref niz[j], ref niz[manji]);
                }
            }
            Razmena(ref niz[desni], ref niz[manji + 1]);
            return manji + 1;
        }

        static void Sort(int[] niz, int levi, int desni)
        {
            if (levi < desni)
            {
                int partitionIndex = Partition(niz, levi, desni);
                Sort(niz, levi, partitionIndex - 1);
                Sort(niz, partitionIndex + 1, desni);
            }
        }
        static void Razmena(ref int a, ref int b)
        {
            int p = a;
            a = b;
            b = p;
        }
        static int Srednji(int a, int b, int c)
        {
            if (a > b) Razmena(ref a, ref b);
            if (a > c) Razmena(ref a, ref c);
            if (b > c) Razmena(ref c, ref b);
            return b;
        }
        static bool ImaLiGa(int[] niz, int a, int trenutni)
        {
            for (int i = 0; i < trenutni; i++)
            {
                if (a == niz[i]) return true;
            }
            return false;
        }
        static int Najvise(int[] niz, int n, ref int broj_ponavljanja)
        {   
            int res = niz[0];
            int sadasnji_broj = 1;

            for (int i = 1; i < n; i++)
            {
                if (niz[i] == niz[i - 1])sadasnji_broj++;
                else
                {
                    if (sadasnji_broj > broj_ponavljanja)
                    {
                        broj_ponavljanja = sadasnji_broj;
                        res = niz[i - 1];
                    }
                    sadasnji_broj = 1;
                }
            }
            if (sadasnji_broj > broj_ponavljanja)
            {
                broj_ponavljanja = sadasnji_broj;
                res = niz[n - 1];
            }
            return res;
        }
        static int BrojIzmedju(int[] niz, int i1, int i2, int max)
        {
            while (i1 < i2 - 1)
            {
                if (niz[i1 + 1] == max) return i1 + 1;
                i1++;
            }
            return -1;
        }
     
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            int[] niz = new int[n];
            int[] stari_niz = new int[n];
            int broj_ponavljanja = 1;
            string[] str = Console.ReadLine().Split();
            for (int i = 0; i < n; i++)
            {
                niz[i] = int.Parse(str[i]);
                stari_niz[i] = niz[i];
            }
            
            Sort(niz, 0, n - 1);
            int[] menjanje = new int[2]; menjanje[0] = -1; menjanje[1] = -1;
            int br = 0;
            int max_pojavljivanja = Najvise(niz, n, ref broj_ponavljanja);

            for (int i = 0; i < n; i++)
            {
                if (stari_niz[i] != max_pojavljivanja && menjanje[0] == -1 && i != n - 1)
                {
                    menjanje[0] = i;
                }
                else if (stari_niz[i] != max_pojavljivanja && menjanje[0] != -1 && i != n - 1)
                {
                    menjanje[1] = i;
                    if (BrojIzmedju(stari_niz, menjanje[0], menjanje[1], max_pojavljivanja) != -1)
                    {
                        stari_niz[menjanje[0]] = max_pojavljivanja;
                        stari_niz[menjanje[1]] = max_pojavljivanja;
                        br++;
                        menjanje[0] = -1;
                    }               
                }
                else if (i == n - 1 && stari_niz[i] != stari_niz[i - 1])
                {
                    br++;
                    stari_niz[i] = max_pojavljivanja;
                }
            }
            Console.WriteLine();
            Console.WriteLine(br);
          /*  for (int i = 0; i < n; i++)
            {
                Console.Write(stari_niz[i] + " ");
            } */
        }
    }
}