#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const char nl = '\n';

ll stepeni[20];
ll stepCif[10][62];
ll x, y, k;

bool check(ll proba) {
    return proba >= x && proba <= y;
}

const ll GRAN = 1e18;
const ll INF = 1e18;

bool proveri(const vector<ll> &v) {
    ll suma = 0;
    for(int i = 0; i < k; ++i) {
        suma += v[i];
        if(suma > GRAN) {
            return 0;
        }
    }
    return 1;
}

ll cifra(ll taj, int stepen) {
    ll ans = 0;
    while(taj > 0LL) {
        ll tren = taj % 10;
        if(stepCif[tren][stepen] >= INF) {
            return INF;
        }
        ans += stepCif[tren][stepen];
        if(ans >= INF)
            return INF;
        taj /= 10LL;
    }
    return ans;
}

ll izracunaj(const vector<ll> &v, ll taj) {
    ll ans = 0;
    for(int i = 0; i < k; ++i) {
        ll to = cifra(taj, i+1);
        if(to >= INF)
            return INF;
        if(to * v[i] >= INF)
            return INF;
        ans += to * v[i];
        if(ans >= INF)
            return INF;
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    for(int i = 0; i < 10; ++i) {
        stepCif[i][1] = i;
        for(int j = 2; j <= 60; ++j) {
            if(stepCif[i][j-1] >= INF) {
                stepCif[i][j] = INF;
                continue;
            }
            if(stepCif[i][j-1] * 1LL * i >= INF) {
                stepCif[i][j] = INF;
                continue;
            }
            stepCif[i][j] = stepCif[i][j-1] * 1LL * i;
            if(stepCif[i][j] < stepCif[i-1][j]) {
                stepCif[i][j] = INF;
            }
        }
    }

    //for(int i = 0; i < 10; ++i) {
        //for(int j = 0; j < 50; ++j) {
            //cerr << stepCif[i][j] << " ";
        //}
        //cerr << endl;
    //}

    cin >> x >> y >> k;
    vector<ll> v(k);
    for(auto &z : v)
        cin >> z;

    if(!proveri(v)) {
        cout << -1 << nl;
        return 0;
    }

    //cerr << "bu" << endl;

    ll suma = accumulate(v.begin(), v.end(), 0LL);

    stepeni[0] = 1;
    for(int i = 1; i < 20; ++i) {
        stepeni[i] = stepeni[i-1] * 10LL;
    }
    
    if(k >= 60) {
        for(int mask = 0; mask < (1<<18); ++mask) {
            ll num = 0;
            ll cnt = 0;
            for(int i = 0; i < 18; ++i) {
                if((mask>>i)&1) {
                    num += stepeni[i];
                    ++cnt;
                }
            }
            if(check(num) && cnt * suma == num) {
                cout << num << nl;
                return 0;
            }
        }
        if(suma == stepeni[18] && check(stepeni[18])) {
            cout << stepeni[18] << nl;
            return 0;
        }
        cout << -1 << nl;
        return 0;
    }

    for(ll kand = x; kand <= y; ++kand) {
        if(izracunaj(v, kand) == kand) {
            cout << kand << nl;
            return 0;
        }
    }

    cout << -1 << nl;
}