#include <iostream>
#include <vector>

using namespace std;

struct seg_drvo
{
    int sirina;
    vector<pair<long long int, long long int>> stablo;

    void zasadi(int n)
    {
        sirina = 1 << (32 - __builtin_clz(n));
        stablo.assign(2*sirina, make_pair(0LL, 0LL));
    }

    void porasti(vector<pair<long long int, long long int>> &v, int x, int l, int r)
    {
        if(r - l == 1)
        {
            if(l < sirina)
                stablo[x]  = v[l];
            return;
        }

        int m = (l + r) / 2;

        porasti(v, 2*x + 1, l, m);
        porasti(v, 2*x + 2, m, r);

        stablo[x].first = stablo[2*x + 2].first - stablo[x*2 + 1].first;
        stablo[x].second = stablo[2*x + 2].second - stablo[2*x + 1].second;
    }

    void porasti(vector<pair<long long int, long long int>> &v)
    {
        porasti(v, 0, 0, sirina);
    }

    pair<long long int, long long int> kraj(int x, int l, int r, int lx, int rx)
    {
        if(rx <= l || lx >= r)
            return make_pair(0LL, 0LL);

        if(lx >= l && rx <= r)
        {
            auto seg = stablo[x];

            if((r - rx) % 2)
                return make_pair(-seg.first, -seg.second);
            else
                return make_pair(seg.first, seg.second);
        }

        int mx = (lx + rx) / 2;

        auto k1 = kraj(2*x + 1, l, r, lx, mx);
        auto k2 = kraj(2*x + 2, l, r, mx, rx);

        return make_pair(k1.first + k2.first, k1.second + k2.second);
    }

    pair<long long int, long long int> kraj(int l, int r)
    {
        return kraj(0, l, r, 0, sirina);
    }
};

int main(void)
{
    ios::sync_with_stdio(false);

    int n, q, l, r;
    long long int x, y;
    vector<pair<long long int, long long int>>  stubovi;

    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> x >> y;
        stubovi.push_back(make_pair(x, y));
    }

    seg_drvo jablan;
    jablan.zasadi(n);
    jablan.porasti(stubovi);

    cin >> q;
    while(q--)
    {
        cin >> x >> y >> l >> r;

        auto seg = jablan.kraj(l-1, r);

        if((r - l + 1) % 2)
            cout << -x + 2*seg.first << " " << -y + 2*seg.second << "\n";
        else
            cout << x + 2*seg.first << " " << y + 2*seg.second << "\n";
    }

    return 0;
}