#include <iostream>
#include <vector>

using namespace std;

struct Vector2
{
	int32_t x;
	int32_t y;
	inline Vector2() {};
	inline Vector2(int32_t pX, int32_t pY) { x = pX; y = pY; };
	Vector2 operator+(const Vector2& a) const
	{
		return Vector2(x + a.x, y + a.y);
	}

	Vector2 operator-(const Vector2& a) const
	{
		return Vector2(x - a.x, y - a.y);
	}

	Vector2 operator*(const int num) const
	{
		return Vector2(x * num, y * num);
	}
};

struct Scenario
{
	Vector2 pos;
	int32_t l;
	int32_t r;
};

int32_t n, q;
std::vector<Vector2> stubs;
std::vector<Scenario> scenarios;

void solve()
{
	for (size_t i = 0; i < q; i++)
	{
		Scenario scenario = scenarios[i];
		Vector2 destination = Vector2(0, 0);
		destination = (stubs[scenario.l - 1] - scenario.pos) * 2 + scenario.pos;
		for (size_t j = scenario.l; j <= scenario.r - 1; j++)
			destination = destination + (stubs[j] - destination) * 2;
		cout << destination.x << " " << destination.y << '\n';
	}
}


int main()
{
	std::ios_base::sync_with_stdio(false);
	cin.tie();
	cout.tie();
	cin >> n;
	stubs.reserve(n);
	for (size_t i = 0; i < n; i++)
	{
		Vector2 stub;
		cin >> stub.x >> stub.y;
		stubs.push_back(stub);
	}
	cin >> q;
	scenarios.reserve(q);
	for (size_t i = 0; i < q; i++)
	{
		Scenario s;
		cin >> s.pos.x >> s.pos.y >> s.l >> s.r;
		scenarios.push_back(s);
	}
	solve();
	return EXIT_SUCCESS;
}