#include <iostream>
#include <algorithm>
#include <vector>
#include <limits.h>
#include <set>
using namespace std;
typedef long long ll;

bool all_digits_one(ll n)
{
	while (n > 0)
	{
		ll digit = n % 10;
		if (digit != 1)
		{
			return false;
		}
		n /= 10;
	}
	return 1;
}
bool has_only_one_and_two(ll n)
{
	while (n > 0)
	{
		ll digit = n % 10;
		if (digit > 2 || digit == 0)
		{
			return false;
		}
		n /= 10;
	}
	return 1;
}

ll perm_to_number(const vector<int>& perm)
{
	ll num = 0;
	for (int i = 0; i < perm.size(); i++)
	{
		num *= 10;
		num += perm[i];
	}
	return num;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	ll l, r, k;
	cin >> l >> r >> k;
	ll sum = 0;
	vector<ll> elements(k);
	for (size_t i = 0; i < k; i++)
	{
		ll element; cin >> element;
		elements[i] = element;
		if (sum <= r)
		{
			sum += element;
		}
	}
	if (k > 70)
	{
		bool possible = 0;
		for (ll i = 1; i <= 18 && sum <= r; i++)
		{
			ll prod = i * sum;
			if (all_digits_one(prod) && prod >= l && prod <= r)
			{
				possible = 1;
				cout << prod << "\n";
				break;
			}
		}
		if (!possible)
		{
			cout << "-1\n";
		}
	}
	else
	{
		cout << "-1\n";
	}
	return 0;
}